#-----------------------------------------------------------------------------
# Hold still for a while
# Copyright (c) 2004 David G. Drumright (Ockham)
# Oct. 5, 2004
#-----------------------------------------------------------------------------

from Tkinter import *
import poser
scene = poser.Scene()
TheFig=scene.CurrentFigure()

#-----------------------------------------------------------------------------
# Next section is TK
#------------------------------------------------------------
def Lock(ActorName,Start,End):
    if TheFig:
        OneActor=TheFig.Actor(ActorName)
    else:
        OneActor=scene.Actor(ActorName)

    for F in range(Start,End):
        OneActor.DeleteKeyFrame(F-1)

#------------------------------------------------------------

class App:
    def __init__(self, master, textMessage):
        self.master = master
        master.title("Hold still for a while")

        self.Labelbox = Label(self.master,text="Highlight parts in list, fill in start and end, hit Go.").grid(row=1, column=0,columnspan=3)

        # Lists
        self.ListScroll = Scrollbar(self.master, orient=VERTICAL)
        self.ListScroll.grid( row=2, column=0,sticky=N+S+E)
        self.List = Listbox(self.master, height=25, selectmode=MULTIPLE,yscrollcommand = self.ListScroll.set)
        self.List.grid( row=2, column=1)
        # Set the scrollbar to work
        self.ListScroll["command"] = self.List.yview

        # Fill list with all body parts in selected figure or props
        if TheFig:
            for OneActor in TheFig.Actors():
                Name=OneActor.Name()
                self.List.insert(END,Name)
        else:
            for OneActor in scene.Actors():
                if (OneActor.IsProp()) and ( OneActor.Name() != 'GROUND'):
                    Name=OneActor.Name()
                    self.List.insert(END,Name)

        # Start and end
        Label(self.master,text="Start frame").grid(row=3, column=0)
        self.StartEntry=Entry(self.master,width=5)
        self.StartEntry.grid(row=3,column=1)
        Label(self.master,text="End frame").grid(row=4, column=0)
        self.EndEntry=Entry(self.master,width=5)
        self.EndEntry.grid(row=4,column=1)

        # Go/nogo buttons.
        self.buttonGo = Button(self.master, text="Go", command=self.HandleGo)
        self.buttonGo.grid(row=5, column=0)

        self.buttonCancel = Button(self.master, text="Cancel", command=self.HandleCancel)
        self.buttonCancel.grid(row=5, column=2)

        self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)


    # - - - - - - - - - - - - - - - - - -

    def Update(self):
        if scene: scene.ProcessSomeEvents(1)
        root.lift()
        root.after(100, self.Update)

    # - - - - - - - - - - - - - - - - - -

    def HandleGo(self):
        SF=self.StartEntry.get()
        if SF: Start=int(SF)
        else: Start=1
        EF=self.EndEntry.get()
        if EF: End=int(EF)
        else: End=scene.NumFrames()

        Sels=self.List.curselection()
        if not Sels:  # Do all in list
            for OneIndex in range(self.List.size()):
                ActorName=self.List.get(OneIndex)
                Lock(ActorName,Start,End)
        else: # Sels
            for OneIndex in Sels:
                ActorName=self.List.get(int(OneIndex))
                Lock(ActorName,Start,End)

        self.master.destroy()

    # - - - - - - - - - - - - - - - - - -

    def HandleCancel(self):
        self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

root = Tk()
app = App(root, '')
app.Update()
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
